/**
 * Created by cgeek on 5/17/15.
 */
angular.module('controllers.main', ['services.common.auth'])

.controller('AppCtrl', function($ionicModal,$ionicLoading, $ionicPlatform, $ionicHistory,
                                $rootScope, $scope,$state,$ionicPopup, AuthService,
                                $ionicTabsDelegate, $cordovaClipboard, DeviceService) {


    DeviceService.umengLogEvent('app_home_page');

    var localSellerId = window.localStorage.getItem('localSellerId');
    $rootScope.showDash = false;

    if(!localSellerId || localSellerId == 'undefined' || localSellerId <= 0) {
        $rootScope.showDash = false;
    } else {
        $rootScope.showDash = true;
    }
    //已登录的情况

    //tabs hide or show ?
    $rootScope.$on('$ionicView.beforeEnter', function() {
        $rootScope.hideTabs = true;
        if ($state.current.name === 'app.dash' ||
            $state.current.name === 'app.mine' ||
            $state.current.name === 'app.home'
            ) {
            $rootScope.hideTabs = false;
        }
    });

    // Create the login modal that we will use later
    $ionicModal.fromTemplateUrl('templates/modal/login.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.modal = modal;
    });

    $scope.closeLoginModal = function() {
        $scope.modal.hide();
    }

    $scope.loginModal = function() {
        $scope.modal.show();
    }
    $scope.loginModalToRegister = function() {
        $scope.modal.hide();
        $state.go('register/step1');
    }

    //登录
    $scope.loginData = {};

    $scope.loginModalSubmit = function() {
        $ionicLoading.show({template:'正在登录...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 9000);

        AuthService.login($scope.loginData).then(function(r){
            console.log(r);
            if(r.success) {
                $ionicLoading.show({template:'登录成功！'});
                setTimeout(function(){
                    $ionicLoading.hide();
                    $scope.closeLoginModal();
                }, 1000);
            } else {
                $ionicLoading.show({template: r.message});
                setTimeout(function(){
                    $ionicLoading.hide();
                }, 1000);
            }
        });
    }



    $scope.weixinKefu = function(localSeller) {

        var weixin = 'qiugongluevip';
        var template = '<p>微信咨询：<span style="color:#FA440A">' + weixin + '</span><br>服务时间：09:00-21:00(北京时间)<br><br>电话咨询：400-728-0727<br>服务时间：09:00-18:00(北京时间)<br></p>';
        if(localSeller && localSeller.weChat && localSeller.weChat != '' ) {
            weixin = localSeller.weChat;
            template = '<p>微信咨询：<span style="color:#FA440A">' + weixin + '</span></p>';
        }

        var confirmPopup = $ionicPopup.confirm({
            title: '微信咨询',
            template: template,
            cancelText:'取消',
            okText: '复制微信号'
        });
        confirmPopup.then(function(res) {
            if(res) {
                $cordovaClipboard
                    .copy(weixin)
                    .then(function () {
                        var copyPopup = $ionicPopup.confirm({
                            title: '微信咨询',
                            template: '已经复制到剪切板！<p>在微信的搜索框里粘贴即可关注</p>',
                            cancelText:'取消',
                            okText: '打开微信'
                        }).then(function(res2){
                            res2 && (window.location.href = "weixin://");

                        });

                    }, function () {
                        // error
                    });
            }
        });


    }

    //创建目的地选择modal
    $ionicModal.fromTemplateUrl('templates/modal/place-filter-box.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.placeFilterModal = modal;
    });

    $scope.openPlaceFilterBox = function() {
        $scope.placeFilterModal.show();
    }
    $scope.closePlaceFilterBox = function() {
        $scope.placeFilterModal.hide();
    }
    $scope.goToArea = function(areaId, areaName) {
        if(areaId) {
            $scope.placeFilterModal.hide();
            $state.go('app.itemList' , {areaId: areaId, areaName: areaName});
        }
    }
});