/**
 * Created by cgeek on 5/17/15.
 */


angular.module('controllers.auth', [])

.controller('AuthCtrl', function($ionicLoading,$ionicPopup,$timeout, $scope,$rootScope, $state, $stateParams, Constants, AuthService) {

    //已登录的情况
    var isLogin = window.localStorage.getItem('isLogin');
    if(isLogin) {
        $state.go('app.home')
    }


    window.localStorage.setItem('hasViewWelcome', true);

    $rootScope.registerInfo = {};
    $scope.user = {};

    $scope.authenticateUser = function(provider) {
        var error = function(error){
            $ionicLoading.hide();
            if(Constants.DEBUGMODE){
                console.log("AuthenticateUser failed");
                console.log(error);
            }

            $scope.error = error;

            var errorPopup = $ionicPopup.show({
                templateUrl: 'templates/modal/error.html',
                title: 'Error',
                scope: $scope,
                buttons: [{ text: 'Ok' }]
            });

            errorPopup.then(function(res) {
                if(Constants.DEBUGMODE){
                    console.log('Popup close button Tapped!', res);
                }
            });

            $timeout(function() {
                errorPopup.close(); //close the popup after 3 seconds for some reason
            }, 3000);
        }

        var success = function(response) {
            // if the authentication is successful go to profile view
            /*if(Constants.DEBUGMODE){
                console.log("Authentication successful")
                console.log(response);
            }*/

            $ionicLoading.hide();
            $state.go('app.profile');
        }

        $ionicLoading.show({
            template: '加载...'
        });

        // use AuthService to login
        AuthService.login($scope.user,provider).then(success,error);
    }


    var tempMobile = window.localStorage.getItem('tempRegMobile');
    
    $scope.loginData = {};
    if(tempMobile) {
        $rootScope.registerInfo.mobile = tempMobile;
        $scope.loginData.mobile = tempMobile;
    }
    
    $scope.sendSmsCode = function() {
        
        var mobile = $rootScope.registerInfo.mobile;

        if(mobile == undefined) {
            return false;
        }
        window.localStorage.setItem('tempRegMobile', mobile);
        $ionicLoading.show({
            template: '正在发送...'
        });
        $timeout(function(){
            $ionicLoading.hide();
        }, 9000);

        AuthService.sendSmsCode(mobile).then(function(r){
            if(r.success) {
                $state.go('register/step2');
            } else {
                $ionicLoading.show({template: r.message});
                $timeout(function() {
                    $ionicLoading.hide();
                }, 1000);
                return false;
            }
            $ionicLoading.hide();
        }, function(error) {
            $ionicLoading.show({template: error});
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
        });
    }

    $scope.loginAction = function() {
        $ionicLoading.show({template:'正在登录...'});
        $timeout(function(){
            $ionicLoading.hide();
        }, 9000);

        AuthService.login($scope.loginData).then(function(r){
            console.log(r);
            if(r.success) {

                $ionicLoading.show({template:'登录成功！'});
                $timeout(function(){
                    $state.go('app.home');
                }, 1000);
            } else {
                $ionicLoading.show({template: r.message});
                $timeout(function(){
                    $ionicLoading.hide();
                }, 1000);
            }
        });

    }

    $scope.submitRegister = function() {
        $ionicLoading.show({template:'正在注册...'});
        $timeout(function(){
            $ionicLoading.hide();
        }, 9000);


        var mobile = window.localStorage.getItem('tempRegMobile');
        $rootScope.registerInfo.mobile = mobile;
        $rootScope.registerInfo.nickname = mobile.substr(0,6) + '*';

        AuthService.register($rootScope.registerInfo).then(function(r){
            if(r.success) {
                $ionicLoading.show({template:'登录成功！'});
                $timeout(function(){
                    $state.go('app.home');
                }, 1000);
            } else {
                $ionicLoading.show({template: r.message});
                $timeout(function(){
                    $ionicLoading.hide();
                }, 1000);
            }
        });
    }
})
.controller('AuthCtrlStep2',function($ionicLoading,$ionicPopup,$timeout,$scope,$rootScope, $state, $stateParams, Constants, AuthService){

    $scope.leftSecond = 20;
    $scope.flag = false;
    $rootScope.registerInfo = {};
    
    //验证码计时器
    $scope.count = function(){   
        var timer = setInterval(function(){
        $scope.$apply(function(){
            if($scope.leftSecond === 0){
                clearInterval(timer);
                $scope.flag = false;
                $scope.leftSecond = 20;
            }else{
                $scope.flag = true;
                $scope.leftSecond--;
            }
            return false;
        });
      },1000);
    }
    
    $scope.count();
    
    $scope.checkSmsCode = function() {
        
        var mobile = window.localStorage.getItem('tempRegMobile');
        
        if(!mobile) {
            alert('系统错误，返回重发');
            return false;
        }
        
        var code = $rootScope.registerInfo;
        
        if(code == undefined) {
            return false;
        }

        $ionicLoading.show({
            template: '正在校验...'
        });
        
        $timeout(function(){
            $ionicLoading.hide();
        }, 2000);

        AuthService.checkSmsCode(mobile, code).then(function(r){
            
            if(r.success) {
                $state.go('register/step3');
            }else{
                $ionicLoading.show({
                    template: '输入验证码不对'
                });
            }
        }, function(error) {
            $ionicLoading.show({template: error});
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
        });
    }
    
    $scope.resendSmsCode = function () {
        
        $scope.count();
        var mobile = window.localStorage.getItem('tempRegMobile');
        
        if(mobile == undefined) {
            return false;
        }
        $ionicLoading.show({
            template: '正在发送...'
        });
        $timeout(function(){
            $ionicLoading.hide();
        }, 9000);
        AuthService.sendSmsCode(mobile).then(function(r){
            $ionicLoading.show({template:'发送成功！'});
            $timeout(function(){
                $ionicLoading.hide();
            }, 1000);
        }, function(error) {
            $ionicLoading.show({template: error});
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
        });
        
    }
    
});
