/**
 * Created by yangon on 3/7/15.
 */


angular.module('controllers.item.calendar', ['ionic'])
    .controller('ItemCalendarCtrl', function ($scope, $rootScope,$stateParams,$location,dateFilter,CalendarModel) {
    
    var disabledDates = [], 
    currentDate = new Date();
    
    CalendarModel.fetchDate().then(function (result) {
        init(result);
    });

    $scope.dates = [];

    $scope.addTime = function (nowTime) {
        showDate(new Date(nowTime.getFullYear(), nowTime.getMonth() + 1, 1, 3));
    }

    $scope.setDate =function(dateObj) {
        if (isDateDisabled(dateObj)) return;
        $rootScope.startTime = dateObj.date;
        $rootScope.showTime = true;
        $location.path("/app/choose/" + $stateParams.itemId);
    };

    //初始化
    function init(data){
        disabledDates = data;
        showDate(currentDate);  
    }
    
    function showDate(nowDate) {

        var changeMonth = new Date(nowDate.getFullYear(), nowDate.getMonth() + 1, 1, 3);

        var thisMonth = render(nowDate);

        var changeDate = nowDate;

        changeDate = new Date(changeDate.getFullYear(), changeDate.getMonth() + 1, 1, 3);
        var nextMonth = render(changeDate);

        $scope.dates.push({
            thisMonth: thisMonth,
            currentDate: nowDate
        }, {
            thisMonth: nextMonth,
            currentDate: changeMonth
        });

    }

    function render(initialDate) {

        initialDate = new Date(initialDate.getFullYear(), initialDate.getMonth(), 1, 3);

        var currentMonth = initialDate.getMonth() + 1,
            dayCount = new Date(initialDate.getFullYear(), initialDate.getMonth() + 1, 0, 3).getDate(),
            prevDates = dateRange(-initialDate.getDay(), 0, initialDate, false),
            currentMonthDates = dateRange(0, dayCount, initialDate, true),
            lastDate = stringToDate(currentMonthDates[currentMonthDates.length - 1]),
            nextMonthDates = dateRange(1, 7 - lastDate.getDay(), lastDate, false),
            allDates = prevDates.concat(currentMonthDates, nextMonthDates),
            dates = [],
            today = dateFilter(new Date(), 'yyyy-MM-dd');

        var nextMonthInitialDate = new Date(initialDate);

        nextMonthInitialDate.setMonth(currentMonth);

        for (var i = 0; i < allDates.length; i++) {

            var className = "",
                date = allDates[i];

            //日期不可用设置
            if (disabledDates.indexOf(date) != -1) {
                className = 'pickadate-disabled pickadate-unavailable';
            } else {
                className = 'pickadate-enabled';
            }

            if (date === today) {
                className += ' activated';
            }
            
            dates.push({date: date, className: className});
        }

        return dates;
    };

    function isDateDisabled(dateObj) {
        return (/pickadate-disabled/.test(dateObj.className));
    }

    function isDate(obj) {
        return Object.prototype.toString.call(obj) === '[object Date]';
    }

    function stringToDate(dateString) {
            if (isDate(dateString)) return new Date(dateString);
            var dateParts = dateString.split('-'),
                year = dateParts[0],
                month = dateParts[1],
                day = dateParts[2];

            // set hour to 3am to easily avoid DST change
            return new Date(year, month - 1, day, 3);
        }

    function dateRange(first, last, initial, swith, format) {

            var date, i, _i, dates = [];

            if (!format) format = 'yyyy-MM-dd';

            for (i = _i = first; first <= last ? _i < last : _i > last; i = first <= last ? ++_i : --_i) {
                date = stringToDate(initial);
                date.setDate(date.getDate() + i);
                if (true == swith) {
                    dates.push(dateFilter(date, format));
                } else {
                    dates.push('');
                }

            }
            return dates;
        }

 });