/**
 * Created by cgeek on 5/19/15.
 */


angular.module('controllers.item.choose', ['ionic'])

.controller('ItemChooseCtrl', function($scope,$rootScope, $stateParams,$location, $http,$filter, $ionicLoading, $cordovaActionSheet, $cordovaInAppBrowser) {

    $ionicLoading.show({template:'正在加载...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 3000);

        //初始化数据
        $scope.currentContentSetId = 0;  //选择的套餐ID
        $scope.childContentSetList = [];
    
        var itemId = $stateParams.itemId;
        var url = "http://m.shijieyou.com/mobileJson/skuData?id=" +itemId + "&callback=JSON_CALLBACK";

        $scope.load = function() {
            $http.jsonp(url).success(function(result){
                $ionicLoading.hide();
                $scope.contentSetList = result.data.contentSetList;
                $scope.skuDataList = result.data.skuDataList;
                $scope.itemInfo = result.data.itemInfo;
                $scope.itemId = result.data.itemInfo.itemId;
                $scope.totalPrice = result.data.totalPrice;

                // 如果当前是精选零食类目，不显示时间选择框，直接给一个当前时间
                $scope.defaultTimeSet = result.data.defaultTimeSet
                if($scope.defaultTimeSet){
                    $rootScope.startTime = result.data.defaultTimeSet
                }   
                
                //默认已经选择第一个
                $scope.selectedContentSet = $scope.contentSetList[0];
                $scope.selectedContentSet.selected = true;

                $scope.currentContentSetId = $scope.selectedContentSet.id; //默认第一个套餐id为当前套餐ID

                if($scope.selectedContentSet.hasChild) {
                    $scope.childContentSetList = $scope.selectedContentSet.childContentSetList;  //子套餐列表

                    $scope.selectedChildContentSet = $scope.childContentSetList[0]; // 默认选择第一个子套餐
                    $scope.selectedChildContentSet.selected = true;

                    $scope.currentContentSetId = $scope.selectedChildContentSet.id; //默认第一个子套餐id为当前套餐ID
                }
            }).finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        //获取可选四个日期
        $http.jsonp("http://m.shijieyou.com/mobileJson/skuData?id="+itemId+"&callback=JSON_CALLBACK").success(function(data){
            
            $scope.today       = data.data.chooseRecentDays[0].date;
            $scope.yesterday   = data.data.chooseRecentDays[1].date;
            $scope.tomorrow    = data.data.chooseRecentDays[2].date;
            $scope.thedayafter = data.data.chooseRecentDays[3].date;
            $scope.load();

        });

        //刷新
        $scope.doRefresh = function() {
            $scope.load();
        }

        $scope.order = {mobile:'', startTime:'', endTime:''};

        $scope.selectContentSet = function(i, isChild) {
            if(isChild == true) {
                $scope.selectedChildContentSet = $scope.childContentSetList[i]; // 默认选择第一个子套餐
                $scope.currentContentSetId = $scope.selectedChildContentSet.id;

                for(var j =0; j < $scope.childContentSetList.length; j++) {
                    $scope.childContentSetList[j].selected = false;
                }
                $scope.selectedChildContentSet.selected = true;
                updatePrice();
            } else {
                $scope.selectedContentSet = $scope.contentSetList[i];
                for(var j =0; j < $scope.contentSetList.length; j++) {
                    $scope.contentSetList[j].selected = false;

                }
                $scope.selectedContentSet.selected = true;

                //当前套餐是否有子套餐，有则切换子套餐，没有则设选当前套餐为选择套餐
                if($scope.selectedContentSet.hasChild) {
                    for(var j =0; j < $scope.childContentSetList.length; j++) {
                        $scope.childContentSetList[j].selected = false;
                    }
                    $scope.childContentSetList = $scope.selectedContentSet.childContentSetList;
                    $scope.selectedChildContentSet = $scope.childContentSetList[0]; // 默认选择第一个子套餐
                    $scope.selectedChildContentSet.selected = true;

                    $scope.currentContentSetId = $scope.selectedChildContentSet.id; //默认第一个子套餐id为当前套餐ID
                    updatePrice();
                } else {
                    $scope.currentContentSetId = $scope.selectedContentSet.id; //默认第一个子套餐id为当前套餐ID
                    updatePrice();
                }
            }

        };

        $scope.increase = function(i) {
            $scope.skuDataList[i].count += 1;
            updatePrice();
        };
    
        $scope.addDate = function(date){
            $rootScope.startTime = date;
            $rootScope.showTime = true;
        }

        $scope.decrease = function(i){
            if($scope.skuDataList[i].count > 0) {
                $scope.skuDataList[i].count -= 1;
            }
            updatePrice();
        };

        function updatePrice(){
            var updateURL = 'http://m.shijieyou.com/cart/updatePrice?callback=JSON_CALLBACK&item=' + itemId + '&contentSet=' + $scope.currentContentSetId;
            for(var k =0; k < $scope.skuDataList.length; k++) {
                $scope.skuDataList[k].count =  $scope.skuDataList[k].count == 'null' ? 0 :  $scope.skuDataList[k].count;
                updateURL += '&age_' + $scope.skuDataList[k].id + '=' + $scope.skuDataList[k].count;
            }
            $http.jsonp(updateURL).success(function(result) {
                $scope.skuDataList = result.data.skuDataList;
                $scope.totalPrice = result.data.itemPrice;
            });
        }

        $scope.focusPhoneInput = false;
        $rootScope.showTime = false;
    
        $rootScope.startTime = [];

        $scope.submit = function() {
            if($rootScope.startTime.length <= 0) {
                $ionicLoading.show({template:'请选择预订日期'}); 
                $rootScope.showTime = false;
                setTimeout(function(){
                    $ionicLoading.hide();
                }, 1000);
                return ;
            }
            
            $rootScope.startTime = $filter('date')($rootScope.startTime, 'yyyy-MM-dd');

            if($scope.order.mobile.length <= 1) {
                $ionicLoading.show({template:'手机号码不能为空'});
                $scope.focusPhoneInput = true;
                setTimeout(function(){
                    $ionicLoading.hide();
                }, 1000);
                return ;
            }

            var s1 = 'youme' ;
            var s2 = 'ios';

            var addToCartUrl = 'http://m.shijieyou.com/mobileJson/createTrade?callback=JSON_CALLBACK&';
            var data = {
                'item':itemId,
                'startTime': $rootScope.startTime,
                'endTime':  $rootScope.startTime, //结束时间暂时和开始时间一样
                'contentSet':$scope.currentContentSetId,
                'timeSet':'',
                'phoneNum':$scope.order.mobile,
                'mobile':$scope.order.mobile,
                'source' : s1,
                'client_name' : s2
            };

            for(var k =0; k < $scope.skuDataList.length; k++) {
                $scope.skuDataList[k].count =  $scope.skuDataList[k].count == 'null' ? 0 :  $scope.skuDataList[k].count;
                data['age_' + $scope.skuDataList[k].id ] =  $scope.skuDataList[k].count;
            }

            function objToQueryString(obj){
                var k = Object.keys(obj);
                var s = "";
                for(var i=0;i<k.length;i++) {
                    s += k[i] + "=" + encodeURIComponent(obj[k[i]]);
                    if (i != k.length -1) s += "&";
                }
                return s;
            }
            
            
            console.log(data);
            addToCartUrl +=  objToQueryString(data);

            $ionicLoading.show({template:'正在创建订单...'});
            $http.jsonp(addToCartUrl).success(function(result){
                if(result.success == true) {
                    $ionicLoading.hide();
                    
                    var tradeIds = window.localStorage['tradeIds'];

                    if(tradeIds && tradeIds.length > 0) {
                        tradeIds = result.data.tradeId + ','  +  tradeIds;
                    } else {
                        tradeIds = result.data.tradeId;
                    }

                    window.localStorage['tradeIds'] = tradeIds;
                    
                    window.location.href = "#/app/pay/" + result.data.tradeId;
                } else {
                    $ionicLoading.show({template:'订单创建失败！请联系客服'});
                    setTimeout(function(){
                        $ionicLoading.hide();
                    }, 2000);
                }
            })
                .error(function(){
                    $ionicLoading.show({template:'订单创建失败！请联系客服'});
                    setTimeout(function(){
                        $ionicLoading.hide();
                    }, 2000);
                });
        }

});