/**
 * Created by cgeek on 5/17/15.
 */


angular.module('controllers.item.list', ['ionic'])
.controller('ItemListCtrl', function($ionicLoading,$ionicPopup, $timeout,$rootScope,
                                     $scope,$stateParams, $http, $ionicNavBarDelegate) {

    $ionicNavBarDelegate.showBar(true);
    //$ionicNavBarDelegate.showBackButton(false);

    $scope.areaId = $stateParams.areaId;
    $scope.title = $stateParams.areaName;


    $scope.itemList = [];

    var offset = 0;
    var hasMore = true;
    var base_url = 'http://m.shijieyou.com/mobileJson/list?callback=JSON_CALLBACK&onlyLocalSeller=1&areaId=' + $scope.areaId;

    $scope.doRefresh = function() {
        $rootScope.showSideShareBtn = true;

        offset = 0;
        hasMore = true;

        $http.jsonp(base_url)
            .success(function(result){
                $scope.itemList = result.data.listItemVOs;

				$ionicNavBarDelegate.title(result.data.areaName);
            })
            .finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
            });
    }

    $scope.doRefresh();

    $scope.loadMore = function() {
        offset += 10;
        var url = base_url + '&offset=' + offset;
        $http.jsonp(url)
            .success(function(result) {
                for(var i=0; i<result.data.listItemVOs.length; i++ ) {
                    $scope.itemList.push(result.data.listItemVOs[i]);
                }
                if(result.data.listItemVOs.length > 0) {
                    hasMore = true;
                } else {
                    hasMore = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
    };
    $scope.moreDataCanBeLoaded = function() {
        return hasMore;
    }

});
