/**
 * Created by cgeek on 5/19/15.
 */

angular.module('controllers.item.pay', ['ionic'])

.controller('ItemPayCtrl', function($scope,$rootScope, $location, $stateParams,$ionicPopup, $http,
                                    $cordovaActionSheet, $cordovaInAppBrowser, $ionicLoading) {

        $scope.tradeId = $stateParams.tradeId;
        $scope.currentPay = 'alipay';
        $scope.hasAttention = false;
        $scope.attentionChecked = false;
        $scope.agreement = true;


        $scope.paytext = "共需支付";

        //接受特别提示
        $scope.checkAttention = function() {
            if($scope.attentionChecked == true) {
                $scope.attentionChecked = false;
            } else {
                $scope.attentionChecked = true;
            }
        }
        //接受协议
        $scope.checkAgreement = function() {
            if($scope.agreement) {
                $scope.agreement = false;
            } else {
                $scope.agreement = true;
            }
        }

        var url = "http://m.shijieyou.com/mobileJson/paynow?tradeId=" + $scope.tradeId + "&callback=JSON_CALLBACK";
        //刷新
        $scope.doRefresh = function() {
            $http.jsonp(url).success(function(result){
                $scope.totalPrice = result.data.totalPrice;
                if(result.data.totalPrice > 500) {
                    $scope.currentPay = 'payEasy';
                }
                $scope.hasAttention = result.data.hasAttention;
                $scope.attention = result.data.attention;
                $scope.coupon = result.data.coupon;
                if(result.data.coupon) {
                    $scope.paytext = "优惠后应付";
                }
            }).finally(function() {
                $scope.$broadcast('scroll.refreshComplete');
            });
        }
        $scope.$on('$stateChangeSuccess', function() {
            $scope.doRefresh();
        });

        $scope.selectPay = function(pay) {
            $scope.currentPay = pay;
        }
        $scope.goToPay = function() {
            //check checked
            if($scope.hasAttention && !$scope.attentionChecked) {
                $ionicPopup.alert({title: '提示', template: '请先勾选并确认特别提示!'});
                return ;
            }
            if(!$scope.agreement) {
                $ionicPopup.alert({title: '提示', template: '请勾选并同意“《求攻略用户服务条款》“后继续支付'});
                return ;
            }
            if($scope.currentPay == 'alipay') {
                if('undefined' != typeof(cordova)) {
                    $ionicLoading.show({template:'正在跳转支付宝...'});
                    setTimeout(function(){
                        $ionicLoading.hide();
                    }, 2000);
                    $http.get("http://m.shijieyou.com/finance/packageTradeByApp?callback=JSON_CALLBACK&id=" +  $scope.tradeId)
                        .success(function(tradeMap) {
                            var data = {
                                "tradeNO" : tradeMap.tradeNO,
                                "price" : tradeMap.price,
                                "productName" : tradeMap.productName,
                                "productDescription" : tradeMap.productDescription,
                                "notifyURL" : tradeMap.notifyURL,
                                "returnURL" : tradeMap.returnURL,
                                "refreshURL" : tradeMap.refreshURL
                            }
                            $ionicLoading.hide();

                            var Alipay = cordova.require('com.qiugonglue.cordova.alipay.Alipay');
                            Alipay.pay(tradeMap, function(result){
                                $ionicLoading.show({template:'支付成功，前往填写信息'});
                                setTimeout(function() {
                                    $ionicLoading.hide();
                                    window.location.href = "#/app/mine/editTradeInfo/" +  $scope.tradeId;
                                }, 1000);
                            }, function(error){
                                $ionicLoading.show({template:"支付失败! <p> 尝试其他支付方式或联系客服</p>"});
                                setTimeout(function() {
                                    $ionicLoading.hide();
                                }, 2000);
                            });

                        });

                } else {
                    //支付宝支付
                    var url = 'http://m.shijieyou.com/mobile/pay?id=' + $scope.tradeId;
                    openInAppBrower(url);
                }
            } else {
                var url = 'http://m.shijieyou.com/finance/packageTrade?bank=904&mobile=1&id=' + $scope.tradeId;
                openInAppBrower(url);
            }
        }

        var openInAppBrower = function(url) {
            var options = {location: 'no', closebuttoncaption: '关闭', clearcache: 'yes', toobarBar:'yes'};
            $cordovaInAppBrowser.open(url, '_blank', options);
            $rootScope.$on('$cordovaInAppBrowser:loadstart', function(e, event){
                if (event.url.match("mobile/close")) {
                    $cordovaInAppBrowser.close();
                }
                if(event.url.match("payfail")) {
                    $cordovaInAppBrowser.close();
                    $ionicLoading.show({template:"支付失败!<p>尝试其他支付方式或联系客服</p>"});
                    setTimeout(function(){
                        $ionicLoading.hide();
                    }, 2000);
                }
                if(event.url.match("editInfo")) {
                    $cordovaInAppBrowser.close();
                    window.location.href = "#/app/mine/editTradeInfo/" +  $scope.tradeId;
                }
            });
        }

        $scope.openWebView =  function(url) {
            openInAppBrower(url);
        }


});