/**
 * Created by cgeek on 6/1/15.
 */


angular.module('controllers.item.sellerHome', ['ionic', 'nl2br'])
.controller('SellerHomeCtrl', function($scope,$rootScope, $location, $stateParams, $ionicPopup, $http,
                                       $ionicLoading, $ionicNavBarDelegate) {
    var sellerId = $stateParams.localSellerId;


    var url = "http://m.shijieyou.com/mobileJson/localSellerMain?localSellerId=" +sellerId + "&callback=JSON_CALLBACK";
    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function(){
        $ionicLoading.hide();
    }, 3000);

    $scope.isThirdParty = false;
    $scope.loadDetailData = function(isRefresh) {
        //获取详情页面信息
        $http.jsonp(url).success(function(result) {
            $ionicLoading.hide();
            //console.log(result.data);
            $scope.sellerDetail = result.data;

            $rootScope.showSideShareBtn = true;
            $rootScope.shareData = {'title':result.data.localSeller.localSellerName,'cover_image_small': result.data.localSeller.headPic, 'cover_image':result.data.localSeller.headPic, 'url':'http://m.shijieyou.com/mobile/localSellerMain?localSellerId=' + sellerId + '&source=share_localSellerMain', 'content':result.data.localSeller.localSellerName}

            if(result.data.localSeller && result.data.localSeller.localSellerName ) {
                $ionicNavBarDelegate.title(result.data.localSeller.localSellerName);
            }
        }).finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.loadDetailData(false);
    //刷新
    $scope.doRefresh = function() {
        $scope.loadDetailData(true);
    }
})
.controller('SellerReviewListCtrl', function($scope,$rootScope,$location, $stateParams, $ionicPopup, $http, $ionicLoading, $analytics) {
    var sellerId = $stateParams.sellerId;
    var url = "http://m.shijieyou.com/mobileJson/localSellerEvaluateList?localSellerId=" +sellerId + "&callback=JSON_CALLBACK";
    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function(){
        $ionicLoading.hide();
    }, 3000);

    if($location.search().back != null) {
        $rootScope.showNavCloseBtn = true;
    } else {
        $rootScope.showNavCloseBtn = false;
    }

    $scope.loadData = function() {
        $http.jsonp(url).success(function(result){
            $ionicLoading.hide();
            $scope.reviewList = result.data.reviewList;
        }).finally(function() {
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.loadData();
    //刷新
    $scope.doRefresh = function() {
        $scope.loadData();
    }
})
.controller('SellerIntroduceCtrl', function($scope,$rootScope,$location, $stateParams, $ionicPopup, $http, $ionicLoading, $analytics) {
    var sellerId = $stateParams.sellerId;
    var url = "http://m.shijieyou.com/mobileJson/showLocalSellerIntroduce?localSellerId=" +sellerId + "&callback=JSON_CALLBACK";
    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function(){
        $ionicLoading.hide();
    }, 3000);

    if($location.search().back != null) {
        $rootScope.showNavCloseBtn = true;
    } else {
        $rootScope.showNavCloseBtn = false;
    }

    $scope.loadData = function() {
        $http.jsonp(url).success(function(result){
            $ionicLoading.hide();
            $scope.localSellerIntroduce = result.data.localSellerIntroduce;
        }).finally(function() {
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.loadData();
    //刷新
    $scope.doRefresh = function() {
        $scope.loadData();
    }
})
.controller('SellerIntroduceCtrl', function($scope,$rootScope,$location, $stateParams, $ionicPopup, $http, $ionicLoading) {
    var sellerId = $stateParams.localSellerId;

    var url = "http://m.shijieyou.com/mobileJson/showLocalSellerIntroduce?localSellerId=" +sellerId + "&callback=JSON_CALLBACK";
    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function(){
        $ionicLoading.hide();
    }, 3000);

    $scope.loadData = function() {
        $http.jsonp(url).success(function(result){
            $ionicLoading.hide();
            $scope.localSellerIntroduce = result.data.localSellerIntroduce;
        }).finally(function() {
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.loadData();
    //刷新
    $scope.doRefresh = function() {
        $scope.loadData();
    }
})