/**
 * Created by cgeek on 5/17/15.
 */
angular.module('controllers.seller', ['services.models.seller', 'services.models.goods'])

.controller('DashCtrl', function($scope, $rootScope, $state,  SellerModel,GoodsModel, $cordovaActionSheet, $cordovaCamera,
                                 $cordovaImagePicker, $cordovaFileTransfer, $ionicLoading, Constants) {


    $scope.applySeller = function() {
        var isLogin = window.localStorage.getItem('isLogin');
        if(isLogin) {
            $state.go('app.apply');
        } else {
            $scope.loginModal();
        }
    }
    //首页控制面板，统计数据
    $scope.data = {vistorToday:0, weekTradeCount: 0};

    $scope.doRefresh = function() {

        SellerModel.getIndexData().then(function(result) {
            if(result.success) {
                $scope.data = result.data;
            }
            $scope.$broadcast('scroll.refreshComplete');
        });

    }
    $scope.doRefresh();

    $scope.addItem = function() {
        //获取itemID
        GoodsModel.create().then(function(){
            //选择相册
            document.addEventListener("deviceready", function () {
                var options = {
                    title: '请选择商品图片',
                    buttonLabels: ['从手机相册选择'],
                    addCancelButtonWithLabel: '取消',
                    androidEnableCancelButton : true,
                    winphoneEnableCancelButton : true,
                    addDestructiveButtonWithLabel: '拍照'
                };
                $cordovaActionSheet.show(options).then(function(btnIndex) {
                    function uploadImage(imageURI) {
                        if(imageURI) {

                            $ionicLoading.show({template:'正在上传图片...'});

                            var uploadURL = Constants.API.baseURL + '/uploadItemImage';
                            var goodsId = window.localStorage.getItem('tempItemId');
                            $cordovaFileTransfer.upload(uploadURL, imageURI, {fileKey:'file', params:{itemId:goodsId}})
                                .then(function(result) {
                                    $ionicLoading.show({template:'上传成功'});
                                    setTimeout(function(){
                                        $ionicLoading.hide();
                                        $state.go('app.goodsEdit', {goodsId:goodsId });
                                    }, 1000);

                                }, function(err) {
                                    // Error
                                    $ionicLoading.show({template:'上传失败，请重试'});
                                    setTimeout(function(){
                                        $ionicLoading.hide();
                                    }, 1000);
                                    console.log(err);
                                }, function (progress) {
                                });
                        }
                    }

                    cordova.getAppVersion.getVersionNumber(
                        function (code) {
                            if (code > '1.0.0') {
                                var index = btnIndex;
                                var sourceType = 0;
                                if (index == 2) {
                                    sourceType = '1';
                                } else if (index = 1){
                                    sourceType = '2';
                                }else {
                                    return false;
                                }

                                ImageCrop.getPictures(
                                    function (imageURI) {
                                        uploadImage(imageURI);
                                    },
                                    function (err) {
                                        console.log(err);
                                    },
                                    [
                                        {
                                            source: sourceType,
                                            disableFreedomCrop: "1",
                                            disableAspectRatioButton : "1",
                                            defaultAspectRatio : "{3.0, 2.0}",
                                            disableResetButton : "1",
                                            maxWidth: 640.0,
                                            maxHeight: 10000,
                                            quality: 0.7
                                        }
                                    ]
                                );
                            }else {
                                var index = btnIndex;
                                var sourceType = Camera.PictureSourceType.CAMERA;
                                if(index == 2) {
                                    sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                                } else if(index == 1) {
                                    sourceType = Camera.PictureSourceType.CAMERA;
                                } else {
                                    return false;
                                }
                                var camerOptions = {
                                    quality: 80,
                                    destinationType: Camera.DestinationType.FILE_URI,
                                    sourceType: sourceType,
                                    allowEdit: true,
                                    encodingType: Camera.EncodingType.JPEG,
                                    targetWidth: 600,
                                    targetHeight: 400,
                                    popoverOptions: CameraPopoverOptions,
                                    saveToPhotoAlbum: false
                                };

                                $cordovaCamera.getPicture(camerOptions).then(function(imageURI) {
                                    uploadImage(imageURI);
                                }, function(err) {
                                    // error
                                    console.log(err);
                                });
                            }
                        }
                    );
                });

            });
        })


    }

});
