/**
 * Created by cgeek on 5/21/15.
 */


angular.module('controllers.seller.goodsEdit', ['services.models.goods'])

.controller('GoodsEditCtrl', function($scope,$rootScope, $state, $stateParams,$ionicLoading, GoodsModel,
                                      $cordovaActionSheet, $cordovaImagePicker, $cordovaCamera,
                                      $cordovaFileTransfer, Constants, $ionicPopup) {
    //$scope.chat = GoodsService.getOne($stateParams.goodsId);
    //alert('aa');
    $scope.goodsId = $stateParams.goodsId;

    $scope.skuList = [];
    $scope.areaList = [];
    $rootScope.imageList = [];

    var blankSku = {id:'', price:'', unit:'天', name:''};

    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function(){
        $ionicLoading.hide();
    }, 4000);

    GoodsModel.getEditDetail($stateParams.goodsId).then(function (result) {
        if(result.success) {

            $scope.good = result.data.itemInfo;

            $scope.areaList = result.data.areaList;

            $scope.countryList = result.data.areaMapList;


            if(result.data.itemInfo.country > 0) {
                for(var i=0; i< result.data.areaMapList.length; i++) {
                    if(result.data.areaMapList[i].id ==  result.data.itemInfo.country) {
                        $scope.cityList = result.data.areaMapList[i].childrenList;
                    }
                }
            }

            $scope.categoryList = result.data.categoryList;

            //console.log(result.data.itemInfo);

            if(result.data.itemInfo && result.data.itemInfo.skuList && result.data.itemInfo.skuList.length > 0) {
            //if(result.data.itemInfo && result.data.itemInfo.skuList) {
                $scope.skuList = result.data.itemInfo.skuList;
            } else {
                $scope.skuList = result.data.itemInfo.skuList;
                if($scope.skuList.indexOf(blankSku) < 0) {
                    $scope.skuList.push(blankSku);
                }
            }
            if(result.data.itemInfo && result.data.itemInfo.imageList && result.data.itemInfo.imageList.length > 0) {
                $rootScope.imageList = result.data.itemInfo.imageList;
            }
            $ionicLoading.hide();
        }
    });

    $scope.saveItem = function() {
        $ionicLoading.show({template:'正在保存...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 8000);

        GoodsModel.updateItemInfo($scope.good).then(function(){
            window.localStorage.removeItem('tempItemId');

            $ionicLoading.show({template:'保存成功'});
            setTimeout(function(){
                $ionicLoading.hide();
            }, 1000);
        });

    }

    $scope.addSku = function() {
        if($scope.skuList.indexOf(blankSku) < 0) {
            $scope.skuList.push(blankSku);
        }
    }
    $scope.updateSku = function(sku) {
        if(sku.id) {
            if(sku.price && sku.unit && sku.name) {
                GoodsModel.updateSku(sku.id, sku).then(function(r){

                });
            }
        } else {
            if(sku.price && sku.unit && sku.name) {
                GoodsModel.createSku($scope.goodsId, sku).then(function(r) {
                    if(r.success) {
                        sku.id = r.data;
                    }
                });
            }
        }
    }

    $scope.deleteSku = function(sku) {
        $ionicLoading.show({template:'正在删除...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 4000);
        if(sku.id && sku.id >0 ) {
            GoodsModel.deleteSku(sku.id).then(function(r){
                if(r.success) {
                    var index = $scope.skuList.indexOf(sku);
                    if(index >= 0) {
                        $scope.skuList.splice(index, 1);
                    }
                }
                $ionicLoading.hide();
            })
        } else {
            $ionicLoading.hide();
            $scope.skuList.pop();
        }
    }

    $scope.changeCountry = function() {
        if($scope.good.country > 0 &&  $scope.countryList) {
            for(var i=0; i< $scope.countryList.length; i++) {
                if( $scope.countryList[i].id ==  $scope.good.country) {
                    $scope.cityList =  $scope.countryList[i].childrenList;
                }
            }
        }
    }

    $scope.addItemImage = function() {

        var options = {
            title: '请选择商品图片',
            buttonLabels: ['从手机相册选择'],
            addCancelButtonWithLabel: '取消',
            androidEnableCancelButton : true,
            winphoneEnableCancelButton : true,
            addDestructiveButtonWithLabel: '拍照'
        };

        document.addEventListener("deviceready", function () {

            function uploadImage(imageURI) {
                if(imageURI) {
                    var uploadURL = Constants.API.baseURL + '/uploadItemImage';

                    $ionicLoading.show({template:'正在上传图片...'});

                    $cordovaFileTransfer.upload(uploadURL, imageURI, {fileKey:'file', params:{itemId:$scope.goodsId}})
                        .then(function(result) {
                            result = angular.fromJson(result.response);
                            $scope.imageList.push({id:result.data.imageId, path: result.data.imageURL});

                            $ionicLoading.show({template:'上传成功'});
                            setTimeout(function(){
                                $ionicLoading.hide();
                            }, 1000);
                        }, function(err) {
                            // Error
                            $ionicLoading.show({template:'上传失败，请重试'});
                            setTimeout(function(){
                                $ionicLoading.hide();
                            }, 1000);
                            console.log(err);
                        }, function (progress) {
                        });
                }
            }

            $cordovaActionSheet.show(options).then(function(btnIndex) {
                cordova.getAppVersion.getVersionNumber(
                    function (code) {
                        if (code > '1.0.0') {
                            var index = btnIndex;
                            var sourceType = 0;
                            if (index == 2) {
                                sourceType = '1';
                            } else if (index = 1){
                                sourceType = '2';
                            }else {
                                return false;
                            }

                            ImageCrop.getPictures(
                                function (imageURI) {
                                    uploadImage(imageURI);
                                },
                                function (err) {
                                    console.log(err);
                                },
                                [
                                    {
                                        maxWidth: 640.0,
                                        maxHeight: 10000,
                                        source: sourceType,
                                        disableFreedomCrop: "1",
                                        disableAspectRatioButton : "1",
                                        defaultAspectRatio : "{3.0, 2.0}",
                                        disableResetButton : "1"
                                    }
                                ]
                            );
                        }else {
                            var index = btnIndex;
                            var sourceType = Camera.PictureSourceType.CAMERA;
                            if(index == 2) {
                                sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                            } else if(index == 1) {
                                sourceType = Camera.PictureSourceType.CAMERA;
                            } else {
                                return false;
                            }
                            var camerOptions = {
                                quality: 80,
                                destinationType: Camera.DestinationType.FILE_URI,
                                sourceType: sourceType,
                                allowEdit: true,
                                encodingType: Camera.EncodingType.JPEG,
                                targetWidth: 600,
                                targetHeight: 400,
                                popoverOptions: CameraPopoverOptions,
                                saveToPhotoAlbum: false
                            };

                            $cordovaCamera.getPicture(camerOptions).then(function(imageURI) {
                                uploadImage(imageURI);
                            }, function(err) {
                                // error
                                console.log(err);
                            });
                        }
                    }
                );
            });

        });
    }

    $scope.goImageEdit = function(imageInfo) {
        $state.go('app.goodsImageEdit', {obj:imageInfo});
    }

})
.controller('GoodsImageEditCtrl', function($scope,$rootScope, $state, $stateParams,$ionicLoading,
                                           GoodsModel, $ionicHistory) {

    $scope.imageInfo = $stateParams.obj;
    $scope.deleteImage = function() {
        $ionicLoading.show({template:'正在删除...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 8000);

        GoodsModel.deleteImage($scope.imageInfo.id).then(function() {
            $ionicLoading.show({template: '删除成功'});
            setTimeout(function () {
                $ionicLoading.hide();
                var index = $rootScope.imageList.indexOf($scope.imageInfo);
                $rootScope.imageList.splice(index, 1);
                $ionicHistory.goBack()

            }, 1000);
        }, function(error) {
            $ionicLoading.show({template:error});
            setTimeout(function(){
                $ionicLoading.hide();
            }, 1000);
        });
    }

});
