/**
 * Created by cgeek on 6/12/15.
 */
angular.module('controllers.seller.goodsPreview', ['services.models.goods'])

.controller('GoodsPreviewCtrl', function($scope,$rootScope,$state, $location, $stateParams, $ionicPopup, $http,
                                         $ionicLoading, GoodsModel, $ionicNavBarDelegate, $ionicActionSheet, $anchorScroll) {
        $ionicNavBarDelegate.showBar(false);

        $scope.bannerList = [];
        var itemId = $stateParams.itemId;

        var s1 = 'youme';
        var s2 = 'ios';

        var url = "http://m.shijieyou.com/mobileJson/getItemInfo/" + itemId + "?_=1420774135367&callback=JSON_CALLBACK&from=" + s1 + "&client_name=" + s2;
        $ionicLoading.show({template: '正在加载...'});
        setTimeout(function () {
            $ionicLoading.hide();
        }, 3000);

        $scope.isThirdParty = false;
        $scope.loadDetailData = function (isRefresh) {
            //获取详情页面信息
            $http.jsonp(url).success(function (result) {
                $ionicLoading.hide();
                $scope.itemInfo = result.data.itemInfo;
                if (isRefresh) {
                    $scope.bannerList = [];
                }
                for (var i = 0; i < result.data.itemInfo.picsPath.length; i++) {
                    $scope.bannerList.push({link: '', src: result.data.itemInfo.picsPath[i] + '!w640h425'});
                }
                $scope.recommendItems = result.data.guestListData;
                if (result.data.reviewList.length > 0) {
                    $scope.review = result.data.reviewList[0];
                }
                if (result.data.localSeller && result.data.localSeller.isThirdParty) {
                    $scope.isThirdParty = true;
                    $scope.localSeller = result.data.localSeller;
                }
                $scope.couponMessage = result.data.couponMessage;

                $rootScope.showSideShareBtn = true;
                $rootScope.shareData = {
                    'title': $scope.itemInfo.title,
                    'cover_image_small': $scope.itemInfo.coverImagePath + '!w180',
                    'cover_image': $scope.itemInfo.coverImagePath + '!w180',
                    'url': 'http://m.shijieyou.com/mdetail-' + itemId + '-shareDetail-0',
                    'content': $scope.itemInfo.desc
                }
                var recommendURL = 'http://m.shijieyou.com/mobileJson/guessItemListByCurrentItem/' + itemId + '?callback=JSON_CALLBACK';
                $http.jsonp(recommendURL).success(function (res) {
                    $scope.recommendItems = res.data.guestListData;
                });

            }).finally(function () {
                $scope.$broadcast('scroll.refreshComplete');
            });
        }
        $scope.loadDetailData(false);
        //刷新
        $scope.doRefresh = function () {
            $scope.loadDetailData(true);
        }


        $scope.shareItem = function (itemInfo) {
            document.addEventListener("deviceready", function () {
                var shareURL = 'http://m.shijieyou.com/mdetail-' + itemInfo.itemId + '-0-0';

                $ionicActionSheet.show({
                    buttons: [
                        { text: '<b>分享至微信朋友圈</b>' },
                        { text: '分享给微信好友' }
                    ],
                    titleText: '分享',
                    cancelText: '取消',
                    cancel: function() {
                        // 取消时执行
                    },
                    buttonClicked: function(index) {
                        if(index == 0) {
                            $rootScope.shareToWeixin({title: itemInfo.desc, desc: itemInfo.title,
                                url: shareURL, type:'timeline', thumbURL:itemInfo.coverImagePath + "!w120h120"})
                        }
                        if(index ==1 ) {
                            $rootScope.shareToWeixin({title: itemInfo.desc, desc: itemInfo.title,
                                url: shareURL, type:'session', thumbURL:itemInfo.coverImagePath + "!w120h120"})
                        }
                    }
                });



            });
        }

        $scope.showHtml = {notice:true, feeDesc:true, refund:true};
        $scope.showHtmlClick = function(type) {
            if(!$scope.showHtml[type]) {
                $scope.showHtml[type] = true;
            } else {
                $scope.showHtml[type] = false;
            }

            $anchorScroll();
        }



        $scope.deleteItem = function(good) {
            var confirmPopup = $ionicPopup.confirm({
                title: '删除服务',
                template: '确定要删除该服务吗?',
                cancelText: '取消',
                okText: '确定'

            });
            confirmPopup.then(function(res) {
                if(res) {
                    GoodsModel.delete(good.itemId).then(function(r){
                        //alert('删除成功！');
                        $state.go('app.goodsList')
                    });
                }
            });
        }


    })