/**
 * Created by cgeek on 5/21/15.
 */


angular.module('controllers.seller.shopEdit', ['services.models.seller'])

.controller('SellerEditCtrl', function($scope, $rootScope, SellerModel, $cordovaActionSheet, $cordovaCamera,
                                  $cordovaImagePicker, $cordovaFileTransfer,$state, $ionicLoading) {

    //$rootScope.localSeller = {};

    $scope.doRefresh = function() {
        $ionicLoading.show({template:'正在加载...'});
        setTimeout(function() {
            $ionicLoading.hide();
        }, 3000);

        SellerModel.get(window.localStorage.getItem('userId')).then(function(result){
            if(result.success) {
                $rootScope.localSeller = result.data.localSeller;
            }

            $ionicLoading.hide();

            $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.doRefresh();

    $scope.saveSeller = function() {
        $ionicLoading.show({template:'正在保存...'});
        setTimeout(function() {
            $ionicLoading.hide();
        }, 4000);

        SellerModel.upateInfo($scope.localSeller).then(function(result){
            if(result.success) {
                $ionicLoading.show({template:'保存成功'});
                setTimeout(function() {
                    $ionicLoading.hide();
                }, 1000);

                console.log(result.data.localSeller);

                $rootScope.localSeller = result.data.localSeller;
            } else {
                $ionicLoading.hide();
            }
        });
    }

    //替换背景图片
    $scope.changeBgImage = function() {
        var params = {};
        params.localSellerId = window.localStorage.getItem('localSellerId');
        if(!params.localSellerId || params.localSellerId == 'undefined') {
            alert('系统错误')
            $state.go('app.dash');
            return false;
        }


        document.addEventListener("deviceready", function () {
            var options = {
                title: '请选择图片',
                buttonLabels: ['从手机相册选择'],
                addCancelButtonWithLabel: '取消',
                androidEnableCancelButton: true,
                winphoneEnableCancelButton: true,
                addDestructiveButtonWithLabel: '拍照'
            };
            $cordovaActionSheet.show(options).then(function (btnIndex) {

                function uploadImage(imageURI) {
                    if (imageURI) {
                        $ionicLoading.show({template: '正在上传图片...'});
                        var uploadURL = 'http://www.shijieyou.com/youMeApi/updateSellerBg';
                        $cordovaFileTransfer.upload(uploadURL, imageURI, {params: params})
                            .then(function (result) {
                                result = angular.fromJson(result.response);
                                if(result.success) {
                                    if(result.data && result.data.imageURL) {
                                        $rootScope.localSeller.backgroundImage = result.data.imageURL + '!w160h106';
                                    }
                                    $ionicLoading.show({template:'图片上传成功'});
                                    setTimeout(function() {
                                        $ionicLoading.hide();
                                    }, 1000);
                                } else {
                                    $ionicLoading.show({template:'上传失败，请重试'});
                                    setTimeout(function() {
                                        $ionicLoading.hide();
                                    }, 1000);
                                }

                            }, function (err) {
                                // Error
                                $ionicLoading.show({template: '上传失败，请重试'});
                                setTimeout(function () {
                                    $ionicLoading.hide();
                                }, 1000);
                                console.log(err);
                            }, function (progress) {
                            });
                    }
                }

                cordova.getAppVersion.getVersionNumber(
                    function (code) {
                        if (code > '1.0.0') {
                            var index = btnIndex;
                            var sourceType = 0;
                            if (index == 2) {
                                sourceType = '1';
                            } else if (index = 1){
                                sourceType = '2';
                            }else {
                                return false;
                            }

                            ImageCrop.getPictures(
                                function (imageURI) {
                                    uploadImage(imageURI);
                                },
                                function (err) {
                                    console.log(err);
                                },
                                [
                                    {
                                        maxWidth: 640.0,
                                        maxHeight: 10000,
                                        source: sourceType,
                                        disableFreedomCrop: "1",
                                        disableAspectRatioButton : "1",
                                        defaultAspectRatio : "{3.0, 2.0}",
                                        disableResetButton : "1",
                                        quality: 0.7
                                    }
                                ]
                            );
                        }else {
                            var index = btnIndex;
                            var sourceType = Camera.PictureSourceType.CAMERA;
                            if(index == 2) {
                                sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                            } else if(index == 1) {
                                sourceType = Camera.PictureSourceType.CAMERA;
                            } else {
                                return false;
                            }
                            var camerOptions = {
                                quality: 80,
                                destinationType: Camera.DestinationType.FILE_URI,
                                sourceType: sourceType,
                                allowEdit: true,
                                encodingType: Camera.EncodingType.JPEG,
                                targetWidth: 600,
                                targetHeight: 400,
                                popoverOptions: CameraPopoverOptions,
                                saveToPhotoAlbum: false
                            };

                            $cordovaCamera.getPicture(camerOptions).then(function(imageURI) {
                                uploadImage(imageURI);
                            }, function(err) {
                                // error
                                console.log(err);
                            });
                        }
                    }
                );
            });

        });
    }
});
