/**
 * Created by cgeek on 5/18/15.
 */

angular.module('controllers.user', ['services.models.user'])

.controller('UserCtrl', function($ionicModal,$ionicLoading, $ionicPlatform,  $scope, $rootScope,
                                 $state, $ionicPopup,UserModel, $ionicActionSheet) {

    var userInfo = window.localStorage.getItem('userInfo');

    $rootScope.loginUserInfo = angular.fromJson(userInfo);

    $scope.logout = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: '退出登录',
            template: '确定要退出登录吗?',
            cancelText: '取消',
            okText: '确定'

        });
        confirmPopup.then(function(res) {
            if(res) {
                window.localStorage.removeItem('isLogin');
                window.localStorage.removeItem('userId');
                window.localStorage.removeItem('localSellerId');
                window.localStorage.removeItem('nickName');
                window.localStorage.removeItem('mobile');
                window.localStorage.removeItem('token');
                window.localStorage.removeItem('userInfo');

                $rootScope.isLogin = false;

                $rootScope.showDash = false;

                $state.go('welcome');
            }
        });
    }


    $scope.shareApp = function() {
        document.addEventListener("deviceready", function () {
            var shareURL = 'http://www.qiugonglue.com/youme/download';

            var shareData = {
                title:"游觅，发现不一样的旅行",
                desc:"通过一个人,了解一座城市!",
                imageURL: 'http://qimages.b0.upaiyun.com/c4c2c0f61eae6f98f8cfad006ebb1ff1_big.jpg'
            };

            $ionicActionSheet.show({
                buttons: [
                    { text: '<b>分享至微信朋友圈</b>' },
                    { text: '分享给微信好友' }
                ],
                titleText: '分享',
                cancelText: '取消',
                cancel: function() {
                    // 取消时执行
                },
                buttonClicked: function(index) {
                    if(index == 0) {
                        $rootScope.shareToWeixin({title:shareData.title, desc:shareData.desc,
                            url: shareURL, type:'timeline', thumbURL:shareData.imageURL})
                    }
                    if(index ==1 ) {
                        $rootScope.shareToWeixin({title: shareData.title, desc: shareData.desc,
                            url: shareURL, type:'session', thumbURL:shareData.imageURL})
                    }
                }
            });
        });
    }

    $scope.saveUserInfo = function() {
        //var nickname = $scope.loginUserInfo.nickname;

        UserModel.updateInfo($scope.loginUserInfo).then(function(r) {
            //console.log(r);
        });
    }

    //替换背景图片
    $scope.changeBgImage = function() {
        var params = {};

        document.addEventListener("deviceready", function () {
            var options = {
                title: '请选择图片',
                buttonLabels: ['从手机相册选择'],
                addCancelButtonWithLabel: '取消',
                androidEnableCancelButton: true,
                winphoneEnableCancelButton: true,
                addDestructiveButtonWithLabel: '拍照'
            };
            $cordovaActionSheet.show(options).then(function (btnIndex) {
                var index = btnIndex;
                var sourceType = Camera.PictureSourceType.CAMERA;
                if (index == 2) {
                    sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                } else if (index == 1) {
                    sourceType = Camera.PictureSourceType.CAMERA;
                } else {
                    return false;
                }
                var camerOptions = {
                    quality: 80,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: sourceType,
                    allowEdit: true,
                    encodingType: Camera.EncodingType.JPEG,
                    targetWidth: 600,
                    targetHeight: 400,
                    popoverOptions: CameraPopoverOptions,
                    saveToPhotoAlbum: false
                };

                $cordovaCamera.getPicture(camerOptions).then(function (imageURI) {
                    if (imageURI) {
                        $ionicLoading.show({template: '正在上传图片...'});
                        var uploadURL = 'http://www.qiugonglue.com/api/v3/youme/postUserAvatar';
                        $cordovaFileTransfer.upload(uploadURL, imageURI, {params: params})
                            .then(function (result) {
                                result = angular.fromJson(result.response);
                                if(result.success) {
                                    if(result.data && result.data.imageURL) {

                                    }
                                    $ionicLoading.show({template:'图片上传成功'});
                                    setTimeout(function() {
                                        $ionicLoading.hide();
                                    }, 1000);
                                } else {
                                    $ionicLoading.show({template:'上传失败，请重试'});
                                    setTimeout(function() {
                                        $ionicLoading.hide();
                                    }, 1000);
                                }

                            }, function (err) {
                                // Error
                                $ionicLoading.show({template: '上传失败，请重试'});
                                setTimeout(function () {
                                    $ionicLoading.hide();
                                }, 1000);
                                console.log(err);
                            }, function (progress) {
                            });
                    }

                }, function (err) {
                    // error
                    console.log(err);
                });
            });

        });
    }

});