/**
 * Created by cgeek on 6/1/15.
 */

angular.module('controllers.user.tradeEditInfo', [])
.controller('TradeEditInfoCtrl', function($scope, $rootScope, $state, $stateParams,$location, $http,
                                          $filter, $ionicLoading, $ionicScrollDelegate, $ionicPopup) {
    $rootScope.showSideShareBtn = false;

    $scope.tradeId = $stateParams.tradeId;
    $scope.lineItemId = 0;
    $scope.touristLineItemId = 0;
    $scope.mainTourist = {};
    $scope.touristList = [];
    $scope.currentTourist = {};
    $scope.hotelInfo = {};

    var initFlag = function() {
        $scope.hasHotelInfo = true;
        $scope.hasTouristInfo = true;

        $scope.viewTouristEditBox = true;

        $scope.showMainTouristInfo = false;
        $scope.showMainTouristEdit = true;

        $scope.hasSavedInfo = false;

        $scope.genderList = [{'name':'男', 'value':'男' , 'id':'男'}, {'name':'女', 'value':'女', 'id':'女'}];
    }

    var process_result = function(result) {
        if(result.success) {
            if(!result.data || result.data.length < 1) {
                console.log('error');
                return ;
            }
            var data = result.data[0];

            if(data.mainTourist) {
                $scope.mainTourist = result.data[0].mainTourist;
                $scope.showMainTouristInfo = true;
                $scope.showMainTouristEdit = false;
                $scope.hasSavedInfo = true;
            } else {
                $scope.showMainTouristInfo = false;
                $scope.showMainTouristEdit = true;
                $scope.hasSavedInfo = false;
            }
            if(data.note) {
                $scope.mainTourist.note = data.note;
            }
            if(data.hasTouristInfo) {
                $scope.hasTouristInfo = true;
            } else {
                $scope.hasTouristInfo = false;
            }
            if(data.touristInfo) {
                $scope.touristList = data.touristInfo;
                if($scope.touristList.length > 0) {
                    $scope.viewTouristEditBox = false;
                }
            }
            if(data.lineItemId) {
                $scope.lineItemId = data.lineItemId;
            }
            if(data.hasHotelInfo) {
                $scope.hasHotelInfo = true;
                if(data.hotelInfo) {
                    $scope.hotelInfo = data.hotelInfo;
                }
            } else {
                $scope.hasHotelInfo = false;
            }
            if(data.needTouristInfo) {
                $scope.needTouristInfo = data.needTouristInfo
            }
            if(data) {
                $scope.hasOldInfo = data.hasOldInfo;
                $scope.touristLineItemId = data.touristLineItemId;
            }
            $ionicScrollDelegate.resize();
        } else {
            $ionicLoading.show({template:"订单不存在"});
            setTimeout(function() {
                $ionicLoading.hide();
                $location.path("/mall/account/tradeList").replace();
            }, 2000);
        }

    }


    var url = 'http://m.shijieyou.com/mobileJson/showTouristInfoByTrade?callback=JSON_CALLBACK&tradeId=' + $scope.tradeId;

    $scope.init = function() {
        $ionicLoading.show({template:'正在加载...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 3000);

        initFlag();
        $http.jsonp(url).success(function(result) {
            process_result(result);
            $ionicLoading.hide();
        });
    }
    $scope.init();
    //刷新
    $scope.doRefresh = function() {
        initFlag();
        $http.jsonp(url).success(function(result){
            process_result(result);
            $ionicLoading.hide();
        }).finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
            $ionicLoading.hide();
        });
    }

    /*
     $scope.$on('$stateChangeSuccess', function() {
     $scope.load();
     });
     */

    $scope.editMainTourist = function() {
        $scope.showMainTouristEdit = true;
        $scope.showMainTouristInfo = false;
        $scope.hasSavedInfo = false;

        $ionicScrollDelegate.resize();
    }

    $scope.showAddMoreTouristBtn = false;

    $scope.addMoreTourist = function () {
        $scope.viewTouristEditBox = true;
        $scope.showAddMoreTouristBtn = false;

        $ionicScrollDelegate.resize();

        $scope.currentTourist = {};
    }
    $scope.editTourist = function (index) {
        $scope.viewTouristEditBox = true;
        $scope.showAddMoreTouristBtn = false;

        $scope.hasSavedInfo = false;

        $scope.currentTourist = $scope.touristList[index];
        if($scope.currentTourist.touristBirthday) {
            //$scope.currentTourist.touristBirthday = $filter("date")($scope.currentTourist.touristBirthday, 'yyyy-MM-dd');
            $scope.currentTourist.touristBirthday = new Date($scope.currentTourist.touristBirthday);
        }
        $ionicScrollDelegate.resize();
    }
    $scope.cancelTouristEdit = function() {
        $scope.viewTouristEditBox = false;
        $scope.currentTourist = {};
        $ionicScrollDelegate.resize();
    }

    $scope.deleteTourist = function (index) {
        var confirmPopup = $ionicPopup.confirm({
            title: '删除',
            template: '<p style="text-align:center">确定要删除该旅客信息？</p>',
            cancelText:'返回',
            okText: '确定'
        });
        confirmPopup.then(function(res) {
            if(res) {
                var currentTourist = $scope.touristList[index];
                var url = 'http://www.shijieyou.com/touristInfo/delTourist?touristInfoId=' + currentTourist.id + '&touristLineItemsId='+ $scope.touristLineItemId + '&callback=JSON_CALLBACK';
                $ionicLoading.show({template:'正在删除..'});
                $http.jsonp(url).success(function(result){
                    $ionicLoading.hide();
                    $scope.doRefresh();
                }).finally(function() {
                    $ionicLoading.hide();
                });
            }
        });
        /*
         */
    }

    $scope.saveTouristInfo = function () {

        $scope.viewTouristEditBox = false;
        $scope.showAddMoreTouristBtn = true;

        var saveUrl = 'http://www.shijieyou.com/touristInfo/saveTourist?&callback=JSON_CALLBACK&tradeId='
            + $scope.tradeId + '&lineItemId=' + $scope.lineItemId+ '&';

        function objToQueryString(obj){
            var k = Object.keys(obj);
            var s = "";
            for(var i=0;i<k.length;i++) {
                s += k[i] + "=" + encodeURIComponent(obj[k[i]]);
                if (i != k.length -1) s += "&";
            }
            return s;
        }
        if($scope.currentTourist.id) {
            $scope.currentTourist['touristInfoId'] = $scope.currentTourist.id;
        }
        $scope.currentTourist['touristBirthday'] = $filter('date')($scope.currentTourist['touristBirthday'], "yyyy-MM-dd");
        //$scope.currentTourist.touristGender = '女';
        //$scope.currentTourist['touristBirthday'] = '1987-10-14';
        //console.log($scope.currentTourist['touristBirthday']);
        saveUrl +=  objToQueryString($scope.currentTourist);

        $ionicLoading.show({template:'正在保存旅客信息...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 3000);
        $http.jsonp(saveUrl).success(function(result){
            $ionicLoading.hide();
            if(!$scope.currentTourist.id) {
                $scope.currentTourist.id = result.data.touristInfoId;
                $scope.touristList.push($scope.currentTourist);
            }
        });

    }

    $scope.forms = {};
    $scope.saveAll = function () {
        //校验mainTouristForm
        if($scope.forms.mainTouristForm.$valid) {
            var saveUrl = 'http://m.shijieyou.com/touristInfo/saveTouristInfo?callback=JSON_CALLBACK&tradeId='
                + $scope.tradeId + '&lineItemId=' + $scope.lineItemId + '&';
            var touristInfo = $scope.mainTourist;
            var k = Object.keys(touristInfo);
            var s = "";

            for(var i=0;i<k.length;i++) {
                if(k[i] == 'note') {
                    s += k[i] + "=" + touristInfo[k[i]];
                } else if(k[i] == 'id') {

                } else {
                    s += 'touristInfo_' + k[i] + "=" + touristInfo[k[i]];
                }
                if (i != k.length -1) s += "&";
            }

            saveUrl +=  s;
        } else {
            if($scope.forms.mainTouristForm.touristName.$error.required){
                $ionicLoading.show({template:'请填写主联系人姓名'});
            }
            if($scope.forms.mainTouristForm.touristIdCard.$error.required){
                $ionicLoading.show({template:'请填写主联系人身份证号'});
            }
            if($scope.forms.mainTouristForm.touristPassportNo.$error.required){
                $ionicLoading.show({template:'请填写主联系人护照号'});
            }
            if($scope.forms.mainTouristForm.mainTouristLastName.$error.required){
                $ionicLoading.show({template:'请填写主联系人护照英文名'});
            }
            if($scope.forms.mainTouristForm.touristFirstnameInPassport.$error.required){
                $ionicLoading.show({template:'请填写主联系人护照英文名'});
            }
            if($scope.forms.mainTouristForm.touristEmail.$error.required){
                $ionicLoading.show({template:'请填写主联系人邮箱'});
            }
            if($scope.forms.mainTouristForm.touristMobile.$error.required){
                $ionicLoading.show({template:'请填写主联系人手机号'});
            }

            //$ionicLoading.show({template:'请填写完整主联系人信息'});
            setTimeout(function(){
                $ionicLoading.hide();
            }, 2000);
            return false;
        }

        if($scope.hasHotelInfo) {
            if($scope.forms.hotelForm.$valid) {
                var hotelInfo = $scope.hotelInfo;

                var k = Object.keys(hotelInfo);
                var s = "&";
                for(var i=0;i<k.length;i++) {
                    s += 'hotel_' + k[i] + "=" + hotelInfo[k[i]];
                    if (i != k.length -1) s += "&";
                }
                saveUrl +=  s;
            } else {
                $ionicLoading.show({template:'请填写酒店信息'});
                setTimeout(function(){
                    $ionicLoading.hide();
                }, 2000);
                return false;
            }
        }

        if($scope.hasTouristInfo) {
            if($scope.touristList.length <= 0) {
                $ionicLoading.show({template:'请填写旅客信息'});
                setTimeout(function(){
                    $ionicLoading.hide();
                }, 2000);
                return false;
            }
        }
        $ionicLoading.show({template:'正在保存...'});
        setTimeout(function(){
            $ionicLoading.hide();
        }, 5000);
        $http.jsonp(saveUrl).success(function(result){
            if(result.success) {
                $ionicLoading.hide();
                $scope.doRefresh();
            }
        });
    }


    $scope.editAll = function () {
        $scope.editMainTourist();
    }
})