/**
 * Created by cgeek on 5/19/15.
 */

angular.module('controllers.user.tradeList', [])

.controller('TradeListCtrl', function($scope, $rootScope, $location, $stateParams, $http,
                                      $state, $ionicLoading, $ionicPopup) {
    //alert($location.search().back);
    $rootScope.showSideShareBtn = false;
    if($location.search().back != null) {
        $rootScope.showNavCloseBtn = true;
    } else {
        $rootScope.showNavCloseBtn = false;
    }
    $ionicLoading.show({template:'正在加载...'});
    setTimeout(function() {
        $ionicLoading.hide();
    }, 3000);

    $scope.noTrade = false;
    var tradeIds = window.localStorage['tradeIds'];
    if(!tradeIds || undefined == tradeIds) {
        tradeIds = '';
        $scope.noTrade = true;
    }


    /*
     var url = 'http://m.shijieyou.com/mobileJson/showMyTradeList?callback=JSON_CALLBACK&tradeIds=' + tradeIds;

     $http.jsonp(url).success(function(result){
     $ionicLoading.hide();
     $scope.tradeList = result.data;
     });
     */
    //刷新
    $scope.doRefresh = function() {
        var tradeIds = window.localStorage['tradeIds'];
        if(!tradeIds || undefined == tradeIds) {
            tradeIds = '';
            $scope.noTrade = true;
        } else {
            $scope.noTrade = false;
        }
        var url = 'http://m.shijieyou.com/mobileJson/showMyTradeList?callback=JSON_CALLBACK&tradeIds=' + tradeIds;

        $http.jsonp(url).success(function(result){
            $ionicLoading.hide();
            $scope.tradeList = result.data;
        }).finally(function() {
            $scope.$broadcast('scroll.refreshComplete');
        });
    }

        $scope.$on('$stateChangeSuccess', function() {
            $scope.doRefresh();
        });


    $scope.cancelTrade  = function(tradeId) {
        var confirmPopup = $ionicPopup.confirm({
            title: '取消订单',
            template: '<p style="text-align:center">确定要取消订单？</p>',
            cancelText:'返回',
            okText: '确定'
        });
        confirmPopup.then(function(res) {
            if(res) {
                var url = 'http://m.shijieyou.com/mobileJson/cancel?callback=JSON_CALLBACK&id=' + tradeId;
                $ionicLoading.show({template:'正在取消..'});
                $http.jsonp(url).success(function(result){
                    $ionicLoading.hide();
                    $scope.doRefresh();
                }).finally(function() {
                    $ionicLoading.hide();
                });
            }
        });
    }

    $scope.refundTrade = function() {
        var confirmPopup = $ionicPopup.confirm({
            title: '申请退款',
            template: '<p>请拨打客服电话进行退款</p><p>客服电话:<a href="tel:400-728-0727">400-728-0727</a></p><p>工作时间：工作日9点到18点</p>',
            cancelText:'取消',
            okText: '拨打电话'
        });

        confirmPopup.then(function(res){
            if(res) {
                window.location.href= "tel:400-728-0727";
            }
        });
    }

    $scope.gotoTradeEvaluate = function(tradeId) {
        if(!$scope.isLogin) {
            var QGLPlugin = cordova.require('com.qiugonglue.cordova.QGLPlugin.QGLPlugin');
            QGLPlugin.login(function(result){
                $scope.userInfo = result;
                $scope.isLogin = true;
            }, function(error) {});

            return false;
        }

        window.location.href="#/app/mine/evaluate/" + tradeId;
    }

    $scope.gotoItemDetail = function(itemId) {
        $state.go('app.itemDetail', {itemId:itemId})
    }
})