/**
 * Created by cgeek on 5/17/15.
 */
'use strict';

angular.module('services.common.auth',['services.models.user'])

.service('AuthService', ['$http','$rootScope','$q', 'UserModel', 'Constants',
    function($http, $rootScope, $q, UserModel, Constants){

        var auth = {
            // the user currently logged in
            currentUser: {},

            sendSmsCode : function(mobile) {
                var deferred = $q.defer();
                var data = {'mobile': mobile};

                $http({
                    method: 'POST',
                    url: Constants.API.baseURL + '/sendSmsCode',
                    data: data
                }).success(function(result){
                    deferred.resolve(result);
                }).error(function() {
                    deferred.reject('服务器正忙...');
                });
                
                return deferred.promise;
            },
            checkSmsCode : function(mobile, code) {

                var deferred = $q.defer();
                var data = {'mobile': mobile, 'code': code};

                $http({
                    method: 'POST',
                    url: Constants.API.baseURL + '/checkSmsCode',
                    data: data
                }).success(function(result){
                    deferred.resolve(result);
                }).error(function() {
                    deferred.reject('服务器正忙...');
                });

                return deferred.promise;
            },
            init : function() {

                var isLogin = window.localStorage.getItem('isLogin');
                if(!isLogin || isLogin == null || isLogin == '') {
                    //loginUser = {'user_id': 2, 'localSellerId': 173}

                }

                var self = this;
                /*
                //set the session token in the http header
                $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";
                */
                // getting the userdata if there's any from the localstorage
                //var userData = window.localStorage.getItem('app_user') ||  {profileBg:"", avatar: "", objectId : "", username: "", name : "", bio:"",location:"",website:""};

                //quick check to make sure it's a string ()
                if(typeof(userData) === "string")
                {
                    userData = JSON.parse(userData);
                }

                // setting currentUser
                self.currentUser = new UserModel(userData);
            },


            // registering a user
            register: function(userData){
                var deferred = $q.defer();

                $http({
                    method: 'POST',
                    url: Constants.API.baseURL + '/register',
                    data: userData
                }).success(function(r){
                    if(r.success) {
                        window.localStorage.setItem('isLogin', true);
                        window.localStorage.setItem('userId', r.data.user_id);
                        window.localStorage.setItem('nickname', r.data.nickname);
                        window.localStorage.setItem('localSellerId', r.data.localSellerId);
                        window.localStorage.setItem('token', r.data.token);

                        window.localStorage.setItem('userInfo', angular.toJson(r.data));

                        $rootScope.isLogin = window.localStorage.getItem('isLogin');
                        $rootScope.loginUserInfo = r.data;

                        if(r.data.localSellerId > 0) {
                            $rootScope.showDash = true;
                        }
                    }

                    deferred.resolve(r);
                }).error(function() {
                    deferred.reject('服务器正忙...');
                });

                return deferred.promise;
            },

            // Signing a user in
            login: function(userData){

                var deferred = $q.defer();

                $http({
                    method: 'POST',
                    url: Constants.API.baseURL + '/login',
                    data: userData
                }).success(function(r){
                    if(r.success) {
                        console.log(r.data);
                        window.localStorage.setItem('isLogin', true);
                        window.localStorage.setItem('userId', r.data.user_id);
                        window.localStorage.setItem('nickname', r.data.nickname);
                        window.localStorage.setItem('localSellerId', r.data.localSellerId);
                        window.localStorage.setItem('token', r.data.token);

                        window.localStorage.setItem('userInfo', angular.toJson(r.data));

                        $rootScope.isLogin = window.localStorage.getItem('isLogin');
                        $rootScope.loginUserInfo = r.data;

                        if(r.data.localSellerId > 0) {
                            $rootScope.showDash = true;
                        }
                    }
                    deferred.resolve(r);
                }).error(function() {
                    deferred.reject('服务器正忙...');
                });

                return deferred.promise;
            },

            // function to sign a user out
            logout: function(){
                var self = this;
                var deferred = $q.defer();

                var success = function(response, status, headers, config){
                    self.resetCookie();
                    deferred.resolve(response.payload);
                }

                var error = function(error, status, headers, config){
                    if(error.status === 400){
                        self.resetCookie();
                    }
                    deferred.reject(error);
                }

                $http.get(Constants.API.baseUrl+'/logout').success(success).error(error);

                return deferred.promise;
            }


        }

        return auth;

}]);
