/**
 * Created by cgeek on 5/28/15.
 */

angular.module('services.common.device',[])

.service('DeviceService',function($ionicLoading,$rootScope, $cordovaDevice, $q, $timeout,
                                  $http,$cordovaFile, $cordovaFileTransfer, $cordovaZip) {

    var service = {}

    service.downloadUpdate = function(url) {
        var targetPath = window.cordova.file.cacheDirectory + '/www.zip';
        var trustHosts = true
        var options = {};

        $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
            //console.log('下载成功');
            //console.log(result);
            $ionicLoading.show({template: "正在解压"});
            $cordovaZip.unzip(targetPath, window.cordova.file.cacheDirectory).then(function () {
                console.log('zip success');
                $ionicLoading.hide();
                // REMOVE
                $cordovaFile.removeRecursively(window.cordova.file.documentsDirectory, "www")
                    .then(function (success) {
                        console.log(success);
                        // 移动覆盖www
                        $cordovaFile.moveDir(window.cordova.file.cacheDirectory, "www",
                            window.cordova.file.documentsDirectory, "www")
                            .then(function (success) {
                                console.log('覆盖成功!')
                                console.log(success);
                                window.location.reload();

                                //校验zip文件是否存在, 如果存在，删除zip文件
                                $cordovaFile.checkFile(window.cordova.file.cacheDirectory, "www.zip")
                                    .then(function (success) {
                                        console.log(success);
                                        $cordovaFile.removeFile(window.cordova.file.cacheDirectory, "www.zip")
                                            .then(function (success) {},function(error){});
                                        // success
                                    }, function (error) {
                                        // error
                                        console.log('check zip file error');
                                        console.log(error);

                                    });

                            }, function (error) {
                                // error
                                console.log('覆盖失败');
                                console.log(error);
                            });

                        // success
                    }, function (error) {
                        console.log(error);

                    });

            }, function () {
                console.log('zip error');
                $ionicLoading.hide();
            }, function (progressEvent) {
                //console.log(progressEvent);
                //$ionicLoading.hide();
            });

        }, function (err) {
            console.log(err);
        }, function (progress) {
            //进度，这里使用文字显示下载百分比
            $timeout(function () {
                var downloadProgress = (progress.loaded / progress.total) * 100;
                $ionicLoading.show({
                    template: "正在更新：" + Math.floor(downloadProgress) + "%"
                });
                if (downloadProgress > 99) {
                    $ionicLoading.hide();
                }
            })
        });
    };
    service.init = function() {
        document.addEventListener("deviceready", function () {

            var device = $cordovaDevice.getDevice();
            var cordova = $cordovaDevice.getCordova();
            var model = $cordovaDevice.getModel();
            var platform = $cordovaDevice.getPlatform();
            var uuid = $cordovaDevice.getUUID();
            var version = $cordovaDevice.getVersion();

             var data = {'device': device, 'cordova': cordova, 'model':model,
                'platform':platform, 'uuid': uuid, 'version' : version};

            $http({
                method: 'POST',
                url: "http://www.qiugonglue.com/api/v3/youme/init",
                data: data
            }).success(function(result){

                if(result.code == 200) {
                    var new_version = result.data.www_zip_version;
                    var url = result.data.www_zip_url;
                    console.log('最新版本号' + new_version);
                    if(platform == 'Android') {
							$ionicLoading.show({template:'正在更新版本...'});
							setTimeout(function(){
								$ionicLoading.hide();
							}, 10000);
                            window.AutoUpdate.update(url, new_version, function(success){
								$rootScope.localVersion = success;
                               console.log('update success!');
							   $ionicLoading.hide();
                               window.AutoUpdate.deploy(function(success){}, function(error){});
                            }, function(error){
								$rootScope.localVersion = error;
								$ionicLoading.hide();
                            });

                    } else {

						var currentWWWPath = window.cordova.file.documentsDirectory + '/www/';
						//判断本地版本号和线上版本号区别
						$cordovaFile.checkFile(currentWWWPath, "version.json")
							.then(function (success) {
								// success
								$cordovaFile.readAsText(currentWWWPath, 'version.json').then(function(success){
									var localVersion = angular.fromJson(success);

									console.log('本地版本号' + localVersion.version)
									$rootScope.localVersion = localVersion.version;
									if(localVersion.version && localVersion.version != new_version) {

										console.log('版本号不同，更新')

										service.downloadUpdate(url);

									}

								}, function(error) {

									console.log('读取版本号失败！');
									console.log(error);
								});
							}, function (error) {
								// error
								console.log('读取版本号文件失败！');
								console.log(error);
							});
					}

                }

            }).error(function() {
                console.log('初始化接口失败');
            });

        });
    }

    service.umengLogEvent = function(page, params) {
        if(window.UmengAnalyticsPlugin) {
            params = (params == undefined) ? null: params;
            window.UmengAnalyticsPlugin.event(page, params, function(success){}, function(error){});
        }
    }
    return service;

});
