/**
 * Created by cgeek on 5/22/15.
 */

angular.module('services.models.order',[])

.factory('OrderModel',function($http, $q, Constants){

    var orderModel = {};

    orderModel.getAll = function(){

        var userId = window.localStorage.getItem('userId');

        var deferred = $q.defer();

        var success = function(response){
            deferred.resolve(response);
        }

        var error = function(error){
            deferred.reject(error);
        }

        var url = Constants.API.baseURL + '/tradeList';

        $http.get(url+'?qglUserId=' + userId, {cache: true}).success(success).error(error);
        return deferred.promise;
    }

    //获取交易详情
    orderModel.getOne = function(orderId) {
        var deferred = $q.defer();
        var localSellId = window.localStorage.getItem('localSellerId');


        $http({
            method:'POST',
            url: Constants.API.baseURL  + '/showTradeDetail',
            data : {'tradeId' : orderId, 'sellerId':localSellId }
        }).success(function(result){
            deferred.resolve(result);
        }).error(function(){
            deferred.reject('服务器正忙');
        });

        return deferred.promise;
    }

    //确认订单
    orderModel.confirmOrder = function(orderId) {
        var deferred = $q.defer();
        var localSellId = window.localStorage.getItem('localSellerId');

        $http({
            method:'POST',
            url: Constants.API.baseURL  + '/changeTradeStatus',
            data : {'tradeId' : orderId, 'sellerId':localSellId, 'tradeStatus':'确认' }
        }).success(function(result){
            deferred.resolve(result);
        }).error(function(){
            deferred.reject('服务器正忙');
        });

        return deferred.promise;
    }

    //退款
    orderModel.refund = function(orderId) {
        var deferred = $q.defer();
        var localSellId = window.localStorage.getItem('localSellerId');


        $http({
            method:'POST',
            url: Constants.API.baseURL  + '/changeTradeStatus',
            data : {'tradeId' : orderId, 'sellerId':localSellId, 'tradeStatus':'退款' }
        }).success(function(result){
            deferred.resolve(result);
        }).error(function(){
            deferred.reject('服务器正忙');
        });

        return deferred.promise;
    }

    return orderModel;
});