/**
 * Created by cgeek on 5/18/15.
 */

angular.module('services.models.seller',[])

    .factory('SellerModel',function($http, $q, Constants){

        var sellerModel = {};

        sellerModel.get = function(id){
            var deferred = $q.defer();

            var success = function(response){
                deferred.resolve(response);
            }

            var error = function(error){
                deferred.reject(error);
            }

            var url = Constants.API.baseURL + '/localSellerInfo';

            $http.get(url+'?qglUserId='+id).success(success).error(error);
            return deferred.promise;
        }

        sellerModel.apply = function(applyInfo){
            var deferred = $q.defer();

            $http({
                method:'POST',
                url: Constants.API.baseURL + '/applyLocalSeller',
                data: applyInfo
            }).success(function(data){
                deferred.resolve(data);
            }).error(function(){
                deferred.reject('服务器正忙...');
            });

            return deferred.promise;

        }

        sellerModel.upateInfo = function(sellerInfo){
            var deferred = $q.defer();

            $http({
                method:'POST',
                url: Constants.API.baseURL + '/uploadSellerInfo',
                data: sellerInfo
            }).success(function(data){
                deferred.resolve(data);
            }).error(function(){
                deferred.reject('服务器正忙...');
            });

            return deferred.promise;

        }

        sellerModel.getIndexData = function() {
            var deferred = $q.defer();
            $http({
                url: Constants.API.baseURL + '/summaryStat',
                methode:'GET',
                data: {'user_id': '170'}
            }).success(function(result){
                deferred.resolve(result);
            }).error(function (e) {
                deferred.reject('服务器正忙');
            });
            return deferred.promise;
        }


        return sellerModel;
    });